2010-10-18  Werner Koch  <wk@g10code.com>

	* rndw32.c (slow_gatherer_windowsNT): Add GNUPG_RNDW32_NOPERF envvar.

2010-09-28  Steven M. Schweda  <sms@antinode.info>  (wk)

	Changes to help the VMS port. See
    	http://antinode.info/dec/sw/gnupg.html .

	* random.c [__VMS]: Include rmsdef.h and vms.h.
	(LOCK_SEED_FILE) [__VMS]: Set to 0.
	(getfnc_gather_random) [USE_RNDVMS]: Call rndvms_gather_random.
	(read_seed_file) [__VMS]: Allow reading by others.
	(update_random_seed_file) [__VMS]: Use VMS specific open call.
	* rand-internal.h (rndvms_gather_random): New.

2008-04-17  David Shaw  <dshaw@jabberwocky.com>

	* camellia-glue.c (selftest, camellia_get_info), cipher.c
	(setup_cipher_table): Add Camellia-192.

2008-03-22  Werner Koch  <wk@g10code.com>

	* cipher.c (struct cipher_handle_s): Make sure IV is u32
	aligned.  Change all users of IV.
	(do_cfb_encrypt): Optimize and use bulk code for AES.
	(do_cfb_decrypt): Ditto.
	* rijndael.c (do_encrypt): Remove.
	(do_encrypt_aligned, do_encrypt): New.  Taken from libgcrypt.
	(rijndael_cfb_enc, rijndael_cfb_dec): New.

2007-12-12  Werner Koch  <wk@g10code.com>

	* pubkey.c (pubkey_encrypt, pubkey_decrypt): Allow type 20 keys.
	(pubkey_algo_to_string): Ditto.

2007-12-11  Werner Koch  <wk@g10code.com>

	* pubkey.c (check_pubkey_algo2): Hack to allow decryption using an
	type 20 Elgamal key.

2007-11-29  David Shaw  <dshaw@jabberwocky.com>

	* camellia-glue.c (camellia_get_info), cipher.c
	(setup_cipher_table): Add 128-bit variant of Camellia.

2007-11-28  David Shaw  <dshaw@jabberwocky.com>

	* sha256.c (sha224_get_info): 4880 has an error in the SHA-224 OID
	and we inherited it.  Fixing.

2007-10-23  Werner Koch  <wk@g10code.com>

	Switched entire package to GPLv3+.

2007-07-09  Werner Koch  <wk@g10code.com>

	* camellia.c, camellia.h: Fixed the FSF's postal address.

2007-06-13  David Shaw  <dshaw@jabberwocky.com>

	* Makefile.am, algorithms.h, cipher.c (setup_cipher_table): Add
	Camellia.

	* camellia-glue.c: New.  These are glue functions to interface
	GnuPG to the stock NTT Camellia distribution.

	* camellia.h, camellia.c: New.  Version 1.2.0 of the Camellia code
	(GPL) unchanged from
	http://info.isl.ntt.co.jp/crypt/eng/camellia/index.html

2006-12-11  Werner Koch  <wk@g10code.com>

	* elgamal.c (test_keys): Use new mpi_nlimb_hint_from_nbits
	function.  This also rounds up the value.
	(generate): Use new mpi_nlimb_hint_from_nbits function.
	* rsa.c (test_keys): Ditto.
	(generate): Ditto.
	(rsa_verify): Ditto.
	* primegen.c (generate_elg_prime): Ditto.
	(gen_prime): Ditto.
	* dsa.c (test_keys): Ditto.  This also rounds up the value.

	* Makefile.am (AM_CPPFLAGS): Use instead of INCLUDES.  define
	GNUPG_LIBDIR.

2006-11-03  Werner Koch  <wk@g10code.com>

	* random.c [HAVE_GETTIMEOFDAY]: Included sys/time.h and not
	sys/times.h.  Reported by Rafaël Carré.

2006-06-28  David Shaw  <dshaw@jabberwocky.com>

	* rsa.c (generate): Use e=65537 for new RSA keys.

2006-04-20  David Shaw  <dshaw@jabberwocky.com>

	* dsa.c (dsa2_generate): New function to generate a DSA key with a
	variable sized q.
	(generate): Tweak to allow keys larger than 1024 bits.  Enforce
	that the q size doesn't end between byte boundaries.

2006-04-19  David Shaw  <dshaw@jabberwocky.com>

	* sha256.c (sha224_get_info, sha224_init): New init functions for
	the 224-bit variant of SHA-256.
	* algorithms.h, md.c (load_digest_module): Call them here.

2006-03-20  David Shaw  <dshaw@jabberwocky.com>

	* blowfish.c, md5.c, rmd160.c, sha1.c, sha256.c, sha512.c: Revert
	previous change.  It's now all done in configure.

2006-03-19  David Shaw  <dshaw@jabberwocky.com>

	* blowfish.c, md5.c, rmd160.c, sha1.c, sha256.c, sha512.c: Use
	'#if' rather than '#ifdef' BIG_ENDIAN_HOST.  Harmless as we
	explicitly define BIG_ENDIAN_HOST to 1 when we need it, but needed
	for OSX fat builds when we define BIG_ENDIAN_HOST to another
	macro.

2006-02-14  Werner Koch  <wk@gnupg.org>

	* random.c (lock_seed_file): Build even when not used.

2006-02-09  Werner Koch  <wk@g10code.com>

	* random.c (lock_seed_file): New.
	(read_seed_file, update_random_seed_file): Use it.
	(random_disable_locking): New.

2005-12-06  David Shaw  <dshaw@jabberwocky.com>

	* idea-stub.c (load_module): Not legal to return a void * as a
	function pointer.

	* Makefile.am, rndegd.c, rndlinux.c, rndunix.c, rndw32.c: Some
	cleanup so we don't build files that are completely ifdeffed out.
	This causes a warning on Sun's cc.  Do sha512.c as well for
	consistency.

2005-08-11  Werner Koch  <wk@g10code.com>

	* rijndael.c (rijndael_cfb_encrypt): Experimental code to improve
	AES performance.  Got about 25% on ia32.
	* cipher.c (do_cfb_encrypt): Ditto.

2005-06-07  David Shaw  <dshaw@jabberwocky.com>

	* random.c: Fix prototype of the fast random gatherer.  Noted by
	Joe Vender.

2005-03-23  Werner Koch  <wk@g10code.com>

	* rndw32.c (rndw32_gather_random_fast): While adding data use the
	size of the object and not the one of its address.  Bug reported by 
	Sascha Kiefer.

2005-03-07  Werner Koch  <wk@g10code.com>

	* primegen.c (is_prime): Free A2.  Noted by pmike2001@mail.ru.
	Fixes #423.

2004-11-30  David Shaw  <dshaw@jabberwocky.com>

	* md.c (string_to_digest_algo): Allow read/write SHA384 and
	SHA512.

2004-11-03  Timo Schulz  <twoaday@g10code.com>

        * idea-stub.c (dlopen, dlsym): Use w32_strerror instead of
        just showing the error number.
	
2004-10-14  Werner Koch  <wk@g10code.com>

	* rndunix.c (start_gatherer) [ENABLE_SELINUX_HACKS]: Don't allow
	logging.

2004-10-12  David Shaw  <dshaw@jabberwocky.com>

	* algorithms.h, cast5.c, cipher.c, idea-stub.c, twofish.c,
	blowfish.c, des.c, rijndael.c: Consistently use const for input
	buffers.

2004-09-23  Werner Koch  <wk@g10code.com>

	* rsa.c (rsa_generate): Return the dummy list of factors only if
	the caller asked for it.

2004-05-20  David Shaw  <dshaw@jabberwocky.com>

	* dsa.c (verify): s/exp/exponent/ to fix a compiler warning.  From
	Werner on stable branch.

2004-01-16  David Shaw  <dshaw@jabberwocky.com>

	* cipher.c (setup_cipher_table): May as well call Rijndael AES at
	this point.

	* pubkey.c (setup_pubkey_table), elgamal.c (sign, verify,
	test_keys, elg_sign, elg_verify, elg_get_info): Remove the last
	bits of Elgamal type 20 support.

2003-12-29  David Shaw  <dshaw@jabberwocky.com>

	* idea-stub.c (load_module, idea_get_info): Return the proper type
	for idea_get_info from inside load_module.  From Stefan Bellon.

	* rijndael.c, rndunix.c, twofish.c: Remove dead IS_MODULE code.

	* g10c.c: Dead code.  Remove.

	* Makefile.am: Don't compile g10c.c.

2003-12-28  Stefan Bellon  <sbellon@sbellon.de>

	* rndriscos.c (rndriscos_gather_random) [__riscos__]: Declare
	variable outside loop.

	* blowfish.c, twofish.c [__riscos__]: Removal of unnecessary
	#ifdef __riscos__ sections.

2003-12-17  David Shaw  <dshaw@jabberwocky.com>

	* dsa.h, dsa.c (dsa_verify), elgamal.h, elgamal.c (elg_verify),
	rsa.h, rsa.c (rsa_verify), pubkey.c (dummy_verify, pubkey_verify):
	Remove old unused code.

2003-12-03  David Shaw  <dshaw@jabberwocky.com>

	* pubkey.c (setup_pubkey_table): Don't allow signatures to and
	from encrypt-only Elgamal keys.
	(pubkey_get_npkey, pubkey_get_nskey, pubkey_get_nsig,
	pubkey_get_nenc, pubkey_nbits): Wrap the RSA cheats in !USE_RSA.
	Add cheats for sign+encrypt Elgamal.

2003-11-30  David Shaw  <dshaw@jabberwocky.com>

	* pubkey.c (setup_pubkey_table): Only include RSA if USE_RSA is
	defined.
	(pubkey_get_npkey): Return 2 for RSA even if it isn't available so
	we can at least handle RSA keys.

2003-11-27  Werner Koch  <wk@gnupg.org>

	* pubkey.c (pubkey_sign): Return an error if an ElGamal key is
	used.

	* elgamal.c (gen_k): New arg SMALL_K.
	(sign): Use it here with SMALL_K set to false
	(do_encrypt): and here with SMALL_K set to true.

2003-10-10  Werner Koch  <wk@gnupg.org>

	* primegen.c (gen_prime): Bail out if we try to generate a prime
	with less than 16 bits. Include i18n.h.

2003-10-06  Werner Koch  <wk@gnupg.org>

	* primegen.c (gen_prime): Bail out if NBITS is zero.  This is
	Debian bug #213989 reported by Max <rusmir@tula.net>.

2003-09-04  David Shaw  <dshaw@jabberwocky.com>

	* md.c (string_to_digest_algo): Enable read-write SHA-256 support.

	* algorithms.h, Makefile.am, md.c (load_digest_module,
	string_to_digest_algo), tiger.c: Drop TIGER/192 support.

2003-08-28  David Shaw  <dshaw@jabberwocky.com>

	* idea-stub.c, random.c; s/__MINGW32__/_WIN32/ to help building on
	native Windows compilers.  Requested by Brian Gladman.  From
	Werner on stable branch.

2003-08-21  David Shaw  <dshaw@jabberwocky.com>

	* random.c (getfnc_gather_random): Don't check NAME_OF_DEV_RANDOM
	twice.  Use NAME_OF_DEV_URANDOM.

2003-05-24  David Shaw  <dshaw@jabberwocky.com>

	* bithelp.h, des.c, random.c, rndlinux.c, sha1.c, blowfish.c,
	elgamal.c, rijndael.c, rndunix.c, sha256.c, cast5.c, idea-stub.c,
	rmd160.c, rndw32.c, sha512.c, md5.c, rmd160test.c, rsa.c, tiger.c:
	Edit all preprocessor instructions to remove whitespace before the
	'#'.  This is not required by C89, but there are some compilers
	out there that don't like it.

2003-05-15  David Shaw  <dshaw@jabberwocky.com>

	* cipher.c (setup_cipher_table): #ifdef IDEA.

	* random.c (fast_random_poll): Only use times() if we HAVE_TIMES.

	* sha512.c, tiger.c: Use the U64_C() macro to specify 64-bit
	constants.  U64_C is defined in include/types.h and uses the
	correct suffix depending on the underlying type of u64.

	* idea-stub.c (load_module): Catch an error if the idea module
	file is unloadable for some reason (unreadable, bad permissions,
	etc.)

	* md.c (string_to_digest_algo): Give a warning about TIGER192 not
	being part of OpenPGP.

2003-04-15  Werner Koch  <wk@gnupg.org>

	* md.c (md_start_debug): Need to open the file in binary mode.

2003-02-21  David Shaw  <dshaw@jabberwocky.com>

	* cipher.c (setup_cipher_table): #ifdef all optional ciphers.

	* md.c (load_digest_module): #ifdef all optional digests.

2003-02-11  David Shaw  <dshaw@jabberwocky.com>

	* Makefile.am, md.c (load_digest_module): Only build in SHA384/512
	and TIGER if specifically enabled by the 64-bit type check in
	configure.

2003-02-04  David Shaw  <dshaw@jabberwocky.com>

	* sha256.c, sha512.c: New.

	* Makefile.am, algorithms.h, md.c (load_digest_module,
	string_to_digest_algo): Add read-only support for the new SHAs.

2002-11-06  David Shaw  <dshaw@jabberwocky.com>

 	* rndw32.c [__CYGWIN32__]: Don't include winioctl.h - it is not
	required anymore. (From Werner)

	* random.c (read_seed_file,update_random_seed_file): Use binary
	mode for __CYGWIN__. (From Werner)

	* blowfish.c (burn_stack), cast5.c (burn_stack), des.c
        (burn_stack), md5.c (burn_stack), random.c (burn_stack, read_pool,
	fast_random_poll), rijndael.c (burn_stack), rmd160.c (burn_stack),
	rndegd.c (rndegd_gather_random), rndlinux.c
        (rndlinux_gather_random), sha1.c (burn_stack), tiger.c
	(burn_stack), twofish.c (burn_stack): Replace various calls to
	memset() with the more secure wipememory().

2002-11-02  David Shaw  <dshaw@jabberwocky.com>

	* cipher.c (string_to_cipher_algo), md.c (string_to_digest_algo):
	Allow the Sxxx and Hxxx format for cipher and digest names.

2002-10-31  Stefan Bellon  <sbellon@sbellon.de>

	* rndriscos.c (rndriscos_gather_random): Use riscos_load_module()
	to load CryptRandom module.

2002-10-12  Werner Koch  <wk@gnupg.org>

	* rndunix.c (my_popen): Make sure that stdin and stderr are
	connected to a file.  This is to avoid NetBSD to complain about
	set{u,g}id programs invoked with fd 0, 2 closed.  Reported by
	Cristian Biere.
	(start_gatherer): Likewise. Reordered code.

2002-10-02  David Shaw  <dshaw@jabberwocky.com>

	* tiger.c (tiger_get_info): Select the OID to use for TIGER at
	compile time.

2002-09-27  David Shaw  <dshaw@jabberwocky.com>

	* Makefile.am, md.c (load_digest_module): TIGER is now always
	enabled.

2002-09-26  Werner Koch  <wk@gnupg.org>

	* tiger.c (tiger_get_info): Use a regular OID.  Note that this
	breaks all TIGER generated signatures; if we want to do something
	about it we have to do it in ../g10/sig-check.c .

2002-09-17  Werner Koch  <wk@gnupg.org>

	* rndw32.c (SIZEOF_DISK_PERFORMANCE_STRUCT): Increased to 256.

2002-09-12  Stefan Bellon  <sbellon@sbellon.de>

	* rand-internal.h (rndriscos_gather_random): Added prototype.

2002-08-30  Werner Koch  <wk@gnupg.org>

	* random.c: Automagically detect the entropy gatherer when
	this feature is configured.
	* rndegd.c (rndegd_connect_socket): New.  Factored out from ..
	(rndegd_gather_random): here and call it.
	(do_read): Update the counter variables correctly.  This was not a
	problem due to the way EGD works. Bug found by Christian Biere.

2002-08-20  Werner Koch  <wk@gnupg.org>

	* primegen.c (generate_elg_prime): Return all factors for mode 1.
	Bug reported by Bob Mathews.

2002-08-12  Werner Koch  <wk@gnupg.org>

	* cipher.c: Include the DUMMY cipher only when the new ALLOW_DUMMY
	is defined. It should only be defined for hard core debugging.

2002-08-08  David Shaw  <dshaw@jabberwocky.com>

	* Makefile.am, md.c (load_digest_module): Allow switching TIGER on
	and off via configure.

2002-08-07  David Shaw  <dshaw@jabberwocky.com>

	* md.c (md_algo_present): New function to check if a given algo is
	in use for a given MD_HANDLE.

2002-08-04  Werner Koch  <wk@gnupg.org>

	* blowfish.h, cast5.h, des.h: Removed after moving all prototypes to
	* algorithms.h: here. Changed all sources to use this one.
	
2002-08-03  Stefan Bellon  <sbellon@sbellon.de>

	* idea-stub.c (idea_get_info): RISC OS' Norcroft C needs a cast.
	* random.c (getfnc_gather_random): Added RISC OS support.
	* rndriscos.c: Removed dynload code and tidied up a bit.

2002-08-03  Werner Koch  <wk@gnupg.org>

	* rndegd.c (do_read): Handle case when read returns 0 to avoid
	gpg hanging when EGD died.  By Christian Biere.

2002-08-02  Werner Koch  <wk@gnupg.org>

        The big extension removal.
	
	* Makefile.am: Removed all extension stuff.
	* dynload.c: Removed everything except for
	register_cipher_extension.
	(dynload_enum_module_names): New.
	* dynload.h: Removed.
	* random.c (getfnc_gather_random,getfnc_fast_random_poll):
	New. Replaced all dynload functions with these ones.
	* rndunix.c (rndunix_gather_random): Renamed from
	gather_random.  Made global.  Removed all dynload stuff.
	* rndlinux.c (rndlinux_gather_random): Likewise.
	* rndegd.c (rndegd_gather_random): Likewise.
	* rndw32.c (rndw32_gather_random)
	(rndw32_gather_random_fast): Likewise.  Also removed the unsued
	entropy dll code.
	* md.c (new_list_item): Changed return value to indicate whether
	an algorithms was loaded.
	(load_digest_module): Simplified by removing all the dynload code.
	* algorithms.h: New.
	* md5.c (md5_get_info): Made global.  Removed all dynload stuff.
	* rmd160.c (rmd160_get_info): Likewise. 
	* sha1.c (sha1_get_info): Likewise.
	* tiger.c (tiger_get_info): Likewise. Return NULL if we can't use
	this module.
	* idea-stub.c: New.
	* blowfish.h (idea_get_info): Add prototype.
	* cipher.c (setup_cipher_table): Try to load IDEA.
	(load_cipher_modules): Removed all dynload code.
	* pubkey.c (load_pubkey_modules): Removed the dynloading code.

2002-07-25  David Shaw  <dshaw@jabberwocky.com>

	* random.c: "warning" -> "WARNING"

2002-07-02  Werner Koch  <wk@gnupg.org>

	* rndw32.c (slow_gatherer_windowsNT): Use a simple array for the
	disk performance structure and increase it to the size required by
	W2000.

2002-06-29  Werner Koch  <wk@gnupg.org>

	* rndlinux.c: Removed HAVE_LINUX_RANDOM_H conditional because it
	was never used and the configure test did set the wrong macro
	anyway.

2002-05-07  Stefan Bellon  <sbellon@sbellon.de>

	* md.c (md_start_debug): Use EXTSEP_S instead of ".".

2002-04-24  Werner Koch  <wk@gnupg.org>

	* tiger.c (tiger_final): Removed superfluous token pasting operators.
	* md5.c (md5_final): Ditto.

2002-04-22  Stefan Bellon  <sbellon@sbellon.de>

	* rndriscos.c (func_table): Made func a function pointer.
	(init_device): Improved loading of CryptRandom module.

2002-04-18  Werner Koch  <wk@gnupg.org>

	* rndlinux.c, rndegd.c, rndunix.c (func_table): Made func a
	function pointer.  Note that we still need to change the module
	interface to cope with data vs function pointer problems.  Hmmm,
	even dlsym has a problem with this.

2002-04-10  David Shaw  <dshaw@jabberwocky.com>

	* cipher.c (setup_cipher_table, cipher_open, cipher_encrypt,
	cipher_decrypt, dummy_setkey, dummy_encrypt_block,
	dummy_decrypt_block): the dummy cipher should only be built on
	development versions.

2002-04-06  Werner Koch  <wk@gnupg.org>

	* rijndael.c (rijndael_get_info): We do only support a 128 bit
	blocksize so it makes sense to change the algorithm strings to
	AES.
	* cipher.c (string_to_cipher_algo): Map "RIJNDAEL" to "AES".

2002-02-14  Werner Koch  <wk@gnupg.org>

	* random.c (mix_pool): Removed the failsafe stuff again.  It makes
	the code more complicate and may give the path to more bugs.

2002-02-10  Werner Koch  <wk@gnupg.org>

	* random.c (mix_pool): Carry an extra failsafe_digest buffer
	around to make the function more robust.

2002-02-08  Werner Koch  <wk@gnupg.org>

	* random.c (add_randomness): Xor new data into the pool and not
	just copy it.  This avoids any choosen input attacks which are not
	serious in our setting because an outsider won't be able to mix
	data in and even then we keep going with a PRNG.  Thanks to Stefan
	Keller for pointing this out.

2002-01-02  Stefan Bellon  <sbellon@sbellon.de>

	* rndriscos.c [__riscos__]: Updated include file name.

2001-12-21  Werner Koch  <wk@gnupg.org>

	* Makefile.am (DISCLEANFILES): Add construct.c

2001-12-19  Werner Koch  <wk@gnupg.org>

	* rndw32.c [CYGWIN32]: Include winioctl.h.  By Disastry.

2001-11-08  Werner Koch  <wk@gnupg.org>

	* primegen.c (gen_prime): Set 2 high order bits for secret primes.
	* rsa.c (generate): Loop until we find the exact modulus size.
	Changed the exponent to 41.

2001-10-22  Werner Koch  <wk@gnupg.org>

	* Makefile.am: Need to use $(EXEEXT) where approriate.

2001-09-09  Werner Koch  <wk@gnupg.org>

	* rsa.c (rsa_get_info): s/usage/r_usage/ to avoid shadow warnings.

2001-08-24  Werner Koch  <wk@gnupg.org>

	* md.c (md_write): Made buf arg const.

2001-08-22  Werner Koch  <wk@gnupg.org>

	* random.c (fast_random_poll): Don't use gethrtime if it is broken.

2001-08-20  Werner Koch  <wk@gnupg.org>

	Applied patches from Stefan Bellon <sbellon@sbellon.de> to support
	RISC OS.  Nearly all of these patches are identified by the
	__riscos__ macro.
	* blowfish.c, twofish.c: Added pragmas for use with a Norcraft
	compiler. 
	* dynload.c, md5.c, rmd160.c, sha1.c: Minor patches for RISC OS.
	* rndriscos.c: New.
	* rnd-internal.h: Added prototype.
	* random.c (fast_random_poll): Use '#if defined' instead of just
	'defined'; needed for RISC OS.
	* primegen.c (gen_prime): count? are now ints for consistence
	with is_prime().

2001-08-08  Werner Koch  <wk@gnupg.org>

	* rndw32.c (gather_random): Use toolhelp in addition to the NT
	gatherer for Windows2000.  Suggested by Sami Tolvanen.

	* random.c (read_pool): Fixed length check, this used to be one
	byte to strict.  Made an assert out of it because the caller has
	already made sure that only poolsize bytes are requested.
	Reported by Marcus Brinkmann.

2001-07-18  Werner Koch  <wk@gnupg.org>

	* rndlinux.c (gather_random): casted a size_t arg to int so that
	the format string is correct.  Casting is okay here and avoids
	translation changes. 

2001-06-12  Werner Koch  <wk@gnupg.org>

	* cipher.c (string_to_cipher_algo): Use ascii_strcasecmp().
	* md.c (string_to_digest_algo): Ditto.
	* pubkey.c (string_to_pubkey_algo): Ditto.
	* rndw32.c (slow_gatherer_windowsNT): Ditto.  Not really needed
	here but anyway.

2001-04-29  Werner Koch  <wk@gnupg.org>

	* random.c (fast_random_poll): Do not check the return code of
	getrusage.

2001-04-17  Werner Koch  <wk@gnupg.org>

	* rndunix.c: Add a signal.h header to avoid warnings on Solaris 7
	and 8.

2001-04-16  Werner Koch  <wk@gnupg.org>

	* dynload.c [__MINGW32__]: Applied patch from Timo Schulz to make
	it work under W32.  This patches is based on the one from
	Disastry@saiknes.lv

2001-04-06  Werner Koch  <wk@gnupg.org>

	* rijndael.c, des.c, blowfish.c, twofish.c, cast5.c (burn_stack):
	New.  Add wrappers for most functions to be able to call
	burn_stack after the function invocation. This methods seems to be
	the most portable way to zeroise the stack used. It does only work
	on stack frame based machines but it is highly portable and has no
	side effects.  Just setting the automatic variables at the end of
	a function to zero does not work well because the compiler will
	optimize them away - marking them as volatile would be bad for
	performance.
	* md5.c, sha1.c, rmd160.c, tiger.c (burn_stack): Likewise.
	* random.c (burn_stack): New.
	(mix_pool): Use it here to burn the stack of the mixblock function.
	
2001-04-02  Werner Koch  <wk@gnupg.org>

	* primegen.c (generate_elg_prime): I was not initialized for mode
	!= 1.  Freed q at 3 places.  Thanks to  Tommi Komulainen.

2001-03-28  Werner Koch  <wk@gnupg.org>

	* md5.c (md5_final): Fixed calculation of hashed length.  Thanks
	to disastry@saiknes.lv for pointing out that it was horrible wrong
	for more than 512MB of input.
	* sha1.c (sha1_final): Ditto.
	* rmd160.c (rmd160_final): Ditto.
	* tiger.c (tiger_final): Ditto.

2001-03-19  Werner Koch  <wk@gnupg.org>

	* blowfish.c (encrypt,do_encrypt): Changed name to do_encrypt to
	avoid name clahses with an encrypt function in stdlib.h of
	Dynix/PIX.  Thanks to Gene Carter.
	* elgamal.c (encrypt,do_encrypt): Ditto.

2001-03-12  Werner Koch  <wk@gnupg.org>

	* twofish.c (gnupgext_enum_func): Add some static when comnpiled
	as a module.

	* tiger.c (tiger_get_info): Return "TIGER192" and not just
	"TIGER".  By Edwin Woudt.

2001-03-08  Werner Koch  <wk@gnupg.org>

	* random.c: Always include time.h - standard requirement.  Thanks
	to James Troup.

2001-01-18  Werner Koch  <wk@gnupg.org>

	* rndw32.c: Fixed typo and wrong ifdef for VER_PLATFORM* macro

2001-01-12  Werner Koch  <wk@gnupg.org>

	* cipher.c (cipher_encrypt,cipher_encrypt): Use blocksize and
	not 8 for CBC mode (However: we don't use CBS in OpenPGP).

2000-11-22  Werner Koch  <wk@gnupg.org>

	* rndegd.c (gather_random): Fixed default socket to be '=entropy'.
	Thanks to Tomasz Kozlowski.

2000-10-12  Werner Koch  <wk@gnupg.org>

        * rijndael.c: New.
        * cipher.c: Add Rijndael support.

Wed Oct  4 15:50:18 CEST 2000  Werner Koch  <wk@openit.de>

        * sha1.c (transform): Use rol() macro.  Actually this is not needed
        for a newer gcc but there are still aoter compilers.

Thu Sep 14 14:20:38 CEST 2000  Werner Koch  <wk@openit.de>

        * random.c (fast_random_poll): Check ENOSYS for getrusage.
        * rndunix.c:  Add 2 sources for QNX. By Sam Roberts.

Wed Sep 13 18:12:34 CEST 2000  Werner Koch  <wk@openit.de>

        * rsa.c (secret): Speed up by using the CRT.  For a 2k keys this
        is about 3 times faster.
        (stronger_key_check): New but unused code to check the secret key.

Wed Sep  6 17:55:47 CEST 2000  Werner Koch  <wk@openit.de>

        * rsa.c: Changed the comment about the patent.
        * Makefile.am: Included rsa.[ch].
        * pubkey.c: Enabled RSA support.
        (pubkey_get_npkey): Removed RSA workaround.

Fri Aug 25 16:05:38 CEST 2000  Werner Koch  <wk@openit.de>

        * rndlinux.c (open_device): Loose random device checking.
        By Nils Ellmenreich.

        * rndegd.c (gather_random): Name of socket is nom configurable.

Wed Jun 28 11:54:44 CEST 2000  Werner Koch  <wk@>

  * rsa.c, rsa.h: New based on the old module version (only in CVS for now).
  * pubkey.c (setup_pubkey_table): Added commented support for RSA.

Fri Jun  9 10:09:52 CEST 2000  Werner Koch  <wk@openit.de>

  * rndunix.c (waitpid): New. For UTS 2.1.  All by Dave Dykstra.
  (my_popen): Do the FD_CLOEXEC only if it is available
  (start_gatherer): Cope with missing _SC_OPEN_MAX

Sun May 28 13:55:17 CEST 2000  Werner Koch  <wk@openit.de>

  * random.c (read_seed_file): Binary open for DOSish system
  (update_random_seed_file): Ditto.

  * rndw32.c: Add some debuging code enabled by an environment variable.

Tue May 23 09:19:00 CEST 2000  Werner Koch  <wk@openit.de>

	* rndw32.c: Started with alternative code to replace entropy.dll

Thu May 18 11:38:54 CEST 2000  Werner Koch  <wk@openit.de>

	* primegen.c (register_primegen_progress): New.
	* dsa.c (register_pk_dsa_progress): New.
	* elgamal.c (register_pk_elg_progress): New.

Fri Apr 14 19:37:08 CEST 2000  Werner Koch  <wk@openit.de>

	* twofish.c (twofish_get_info): Fixed warning about cast.

Tue Mar 28 14:26:58 CEST 2000  Werner Koch  <wk@openit.de>

	* random.c [MINGW32]: Include process.h for getpid.

Thu Mar  2 15:37:46 CET 2000  Werner Koch  <wk@gnupg.de>

	* random.c (fast_random_poll): Add clock_gettime() as fallback for
	system which support this POSIX.4 fucntion. By Sam Roberts.

	* rndunix.c: Add some more headers for QNX. By Sam Roberts.

	* random.c (read_seed_file): Removed the S_ISLNK test becuase it
	is already covered by !S_ISREG and is not defined in Unixware.
	Reported by Dave Dykstra.

	* sha1.c (sha1_get_info): Removed those stupid double lines. Dave
	is really a good lint.

Wed Feb 23 10:07:57 CET 2000  Werner Koch  <wk@gnupg.de>

	* twofish.c (twofish_get_info): Add some const to the casts.  By Martin
	Kahlert.

Mon Feb 14 14:30:20 CET 2000  Werner Koch  <wk@gnupg.de>

	(update_random_seed_file): Silently ignore update request when pool
	is not filled.

Fri Feb 11 17:44:40 CET 2000  Werner Koch  <wk@gnupg.de>

	* random.c (read_seed_file): New.
	(set_random_seed_file): New.
	(read_pool): Try to read the seeding file.
	(update_random_seed_file): New.

	(read_pool): Do an initial extra seeding when level 2 quality random
	is requested the first time.  This requestes at least POOLSIZE/2 bytes
	of entropy.  Compined with the seeding file this should make normal
	random bytes cheaper and increase the quality of the random bytes
	used for key generation.

	* rndegd.c (gather_random): Shortcut level 0.
	* rndunix.c (gather_random): Ditto.
	* rndw32.c (gather_random): Ditto.

Fri Jan 14 18:32:01 CET 2000  Werner Koch  <wk@gnupg.de>

	* rmd160.c (rmd160_get_info): Moved casting to the left side due to a
	problem with UTS4.3.  Suggested by Dave Dykstra.
	* sha1.c (sha1_get_info): Ditto.
	* tiger.c (tiger_get_info): Ditto.
	* md5.c (md5_get_info): Ditto
	* des.c (des_get_info): Ditto.
	* blowfish.c (blowfish_get_info): Ditto.
	* cast5.c (cast5_get_info): Ditto.
	* twofish.c (twofish_get_info): Ditto.

Thu Jan 13 19:31:58 CET 2000  Werner Koch  <wk@gnupg.de>

	* elgamal.c (wiener_map): New.
	(gen_k): Use a much smaller k.
	(generate): Calculate the qbits using the wiener map and
	choose an x at a size comparable to the one choosen in gen_k

	* random.c (read_pool): Print a more friendly error message in
	cases when too much random is requested in one call.

	* Makefile.am (tiger): Replaced -O1 by -O. Suggested by Alec Habig.

Sat Dec  4 12:30:28 CET 1999  Werner Koch  <wk@gnupg.de>

	* primegen.c (generate_elg_prime): All primes are now generated with
	the lowest random quality level.  Becuase they are public anyway we
	don't need stronger random and by this we do not drain the systems
	entropy so much.

Thu Oct 28 16:08:20 CEST 1999  Werner Koch  <wk@gnupg.de>

	* random.c (fast_random_poll): Check whether RUSAGE_SELF is defined;
	this is not the case for some ESIX and Unixware, although they have
	getrusage().

	* elgamal.c (sign): Hugh found strange code here. Replaced by BUG().

Mon Oct 11 09:24:12 CEST 1999  Werner Koch  <wk@gnupg.de>

	* rndw32.c (gather_random): Handle PCP_SEEDER_TOO_SMALL.

Sat Oct  9 20:34:41 CEST 1999  Werner Koch  <wk@gnupg.de>

	* Makefile.am:	Tweaked module build and removed libtool

Fri Oct  8 20:32:01 CEST 1999  Werner Koch  <wk@gnupg.de>

	* rndw32.c (load_and_init_winseed): Use the Registry to locate the DLL

Mon Oct  4 21:23:04 CEST 1999  Werner Koch  <wk@gnupg.de>

	* md.c (md_reset): Clear finalized; thanks to Ulf Moeller for
	fixing this bug.

Sat Sep 18 12:51:51 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* Makefile.am: Never compile mingw32 as module

Wed Sep 15 14:39:59 CEST 1999  Michael Roth <mroth@nessie.de>

	* des.c: Various speed improvements: One bit pre rotation
	  trick after initial permutation (Richard Outerbridge).
	  Finished test of SSLeay Tripple-DES patterns.

Wed Sep 15 16:22:17 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* rndw32.c: New.

Mon Sep 13 10:51:29 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* bithelp.h: New.
	* rmd160.h, sha1.h, md5.h: Use the rol macro from bithelp.h

Tue Sep  7 16:23:36 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* Makefile.am: Fixed seds for latest egcc. By Ollivier Robert.

Mon Sep  6 19:59:08 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* des.c (selftest): Add some testpattern

Mon Aug 30 20:38:33 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* cipher.c (do_cbc_encrypt): Fixed serious bug occuring when not using
	in place encryption. Pointed out by Frank Stajano.

Mon Jul 26 09:34:46 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* md5.c (md5_final): Fix for a SCO cpp bug.

Thu Jul 15 10:15:35 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* elgamal.c (elg_check_secret_key,elg_encrypt
	elg_decrypt,elg_sign,elg_verify): Sanity check on the args.
	* dsa.c (dsa_check_secret_key,dsa_sign,dsa_verify): Ditto.

	* pubkey.c (disable_pubkey_algo): New.
	(check_pubkey_algo2): Look at disabled algo table.
	* cipher.c (disable_cipher_algo): New.
	(check_cipher_algo): Look at disabled algo table.

Wed Jul  7 13:08:40 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* Makefile.am: Support for libtool.

Fri Jul  2 11:45:54 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* dsa.c (gen_k): Changed algorithm to consume less random bytes
	* elgamal.c (gen_k): Ditto.

	* random.c (random_dump_stats): New.

Thu Jul  1 12:47:31 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* primegen.c, elgamal.c, dsa.c (progess): New and replaced all
	fputc with a call to this function.

Sat Jun 26 12:15:59 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* rndegd.c (do_write): s/ssize_t/int/ due to SunOS 4.1 probs.

	* cipher.c (do_cbc_encrypt, do_cbc_decrypt): New.

	* dynload.c (HAVE_DL_SHL_LOAD): Map hpux API to dlopen (Dave Dykstra).
	* Makefile.am (install-exec-hook): Removed.

Sun May 23 14:20:22 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* cipher.c (setup_cipher_table): Enable Twofish

	* random.c (fast_random_poll): Disable use of times() for mingw32.

Mon May 17 21:54:43 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* dynload.c (register_internal_cipher_extension): Minor init fix.

Tue May  4 15:47:53 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* primegen.c (gen_prime): Readded the Fermat test. Fixed the bug
	that we didn't correct for step when passing the prime to the
	Rabin-Miller test which led to bad performance (Stefan Keller).
	(check_prime): Add a first Fermat test.

Sun Apr 18 10:11:28 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* cipher.c (cipher_setiv): Add ivlen arg, changed all callers.

	* random.c (randomize_buffer): alway use secure memory because
	we can't use m_is_secure() on a statically allocated buffer.

	* twofish.c: Replaced some macros by a loop to reduce text size.
	* Makefile.am (twofish): No more need for sed editing.

Fri Apr  9 12:26:25 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* cipher.c (cipher_open): Reversed the changes for AUTO_CFB.

	* blowfish.c: Dropped the Blowfish 160 mode.
	* cipher.c (cipher_open): Ditto.
	(setup_cipher_table): Ditto.  And removed support of twofish128

Wed Apr  7 20:51:39 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* random.c (get_random_bits): Can now handle requests > POOLSIZE

	* cipher.c (cipher_open): Now uses standard CFB for automode if
	the blocksize is gt 8 (according to rfc2440).

	* twofish.c: Applied Matthew Skala's patches for 256 bit key.

Tue Apr  6 19:58:12 CEST 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* random.c (get_random_bits): Can now handle requests > POOLSIZE

	* cipher.c (cipher_open): Now uses standard CFB for automode if
	the blocksize is gt 8 (according to rfc2440).

Sat Mar 20 11:44:21 CET 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* rndlinux.c (tty_printf) [IS_MODULE]: Removed.

	* rndegd.c (gather_random): Some fixes.

Wed Mar 17 13:09:03 CET 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* rndegd.c (do_read): New.
	(gather_random): Changed the implementation.

Mon Mar  8 20:47:17 CET 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* dynload.c (DLSYM_NEEDS_UNDERSCORE): Renamed.

Fri Feb 26 17:55:41 CET 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* md.c: Nearly a total rewrote.

Wed Feb 24 11:07:27 CET 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* cipher.c (context): Fixed alignment
	* md.c: Ditto.

	* rndegd.c: New

Mon Feb 22 20:04:00 CET 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* rndegd.c: New.

Wed Feb 10 17:15:39 CET 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* Makefile.am: Modules are now figured out by configure
	* construct.c: New. Generated by configure. Changed all modules
	to work with that.
	* sha1.h: Removed.
	* md5.h: Removed.

	* twofish.c: Changed interface to allow Twofish/256

	* rndunix.c (start_gatherer): Die on SIGPIPE.

Wed Jan 20 18:59:49 CET 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* rndunix.c (gather_random): Fix to avoid infinite loop.

Sun Jan 17 11:04:33 CET 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* des.c (is_weak_key): Replace system memcmp due to bugs
	in SunOS's memcmp.
	(des_get_info): Return error on failed selftest.
	* twofish.c (twofish_setkey): Return error on failed selftest or
	invalid keylength.
	* cast5.c (cast_setkey): Ditto.
	* blowfish.c (bf_setkey): Return error on failed selftest.

Tue Jan 12 11:17:18 CET 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* random.c (random_is_faked): New.

	* tiger.c: Only compile if we have the u64 type

Sat Jan  9 16:02:23 CET 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* rndunix.c (gather_random): check for setuid.

	* Makefile.am: Add a way to staically link random modules

Thu Jan  7 18:00:58 CET 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* md.c (md_stop_debug): Do a flush first.
	(md_open): size of buffer now depends on the secure parameter

Sun Jan  3 15:28:44 CET 1999  Werner Koch  <wk@isil.d.shuttle.de>

	* rndunix.c (start_gatherer): Fixed stupid ==/= bug

1998-12-31  Geoff Keating  <geoffk@ozemail.com.au>

	* des.c (is_weak_key): Rewrite loop end condition.

Tue Dec 29 14:41:47 CET 1998  Werner Koch  <wk@isil.d.shuttle.de>

	* random.c: add unistd.h for getpid().
	(RAND_MAX): Fallback value for Sun.

Wed Dec 23 17:12:24 CET 1998  Werner Koch  <wk@isil.d.shuttle.de>

	* md.c (md_copy): Reset debug.

Mon Dec 14 21:18:49 CET 1998  Werner Koch  <wk@isil.d.shuttle.de>

	* random.c (read_random_source): Changed the interface to the
	random gathering function.
	(gather_faked): Use new interface.
	* dynload.c (dynload_getfnc_fast_random_poll): Ditto.
	(dynload_getfnc_gather_random): Ditto.
	* rndlinux.c (gather_random): Ditto.
	* rndunix.c (gather_random): Ditto.

Sat Dec 12 18:40:32 CET 1998  Werner Koch  <wk@isil.d.shuttle.de>

	* dynload.c (SYMBOL_VERSION): New to cope with system which needs
	underscores.

	* rndunix.c: Rewrote large parts

Thu Dec 10 20:15:36 CET 1998  Werner Koch  <wk@isil.d.shuttle.de>

	* dynload.c (load_extension): increased needed verbosity level.

	* random.c (fast_random_poll): Fallback to a default fast random
	poll function.
	(read_random_source): Always use the faked entroy gatherer if no
	gather module is available.
	* rndlinux.c (fast_poll): Removed.
	* rndunix.c (fast_poll): Removed.


Wed Nov 25 12:33:41 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* rand-*.c: Removed.
	* rndlinux.c : New.
	* rndunix.c : New.
	* random.c : Restructured the interface to the gather modules.
	(intialize): Call constructor functions
	(read_radnom_source): Moved to here.
	* dynload.c (dynload_getfnc_gather_random): New.
	(dynload_getfnc_fast_random_poll): New.
	(register_internal_cipher_extension): New.
	(register_cipher_extension): Support of internal modules.

Sun Nov  8 17:44:36 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* rand-unix.c (read_random_source): Removed the assert.

Mon Oct 19 18:34:30 1998  me,,,  (wk@tobold)

	* pubkey.c: Hack to allow us to give some info about RSA keys back.

Thu Oct 15 11:47:57 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* dynload.c: Support for DLD

Wed Oct 14 12:13:07 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* rand-unix.c: Now uses names from configure for /dev/random.

1998-10-10  SL Baur  <steve@altair.xemacs.org>

	* Makefile.am: fix sed -O substitutions to catch -O6, etc.

Tue Oct  6 10:06:32 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* rand-unix.c (HAVE_GETTIMEOFDAY): Fixed (was ..GETTIMEOFTIME :-)
	* rand-dummy.c (HAVE_GETTIMEOFDAY): Ditto.

Mon Sep 28 13:23:09 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* md.c (md_digest): New.
	(md_reset): New.

Wed Sep 23 12:27:02 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* tiger.c (TIGER_CONTEXT): moved "buf", so that it is 64 bit aligned.

Mon Sep 21 06:22:53 1998  Werner Koch  (wk@(none))

	* des.c: Some patches from Michael.

Thu Sep 17 19:00:06 1998  Werner Koch  (wk@(none))

	* des.c : New file from Michael Roth <mroth@nessie.de>

Mon Sep 14 11:10:55 1998  Werner Koch  (wk@(none))

	* blowfish.c (bf_setkey): Niklas Hernaeus patch to detect weak keys.

Mon Sep 14 09:19:25 1998  Werner Koch  (wk@(none))

	* dynload.c (RTLD_NOW): Now defined to 1 if it is undefined.

Mon Sep  7 17:04:33 1998  Werner Koch  (wk@(none))

	* Makefile.am: Fixes to allow a different build directory

Thu Aug  6 17:25:38 1998  Werner Koch,mobil,,,	(wk@tobold)

	* random.c (get_random_byte): Removed and changed all callers
	to use get_random_bits()

Mon Jul 27 10:30:22 1998  Werner Koch  (wk@(none))

	* cipher.c : Support for other blocksizes
	(cipher_get_blocksize): New.
	* twofish.c: New.
	* Makefile.am: Add twofish module.

Mon Jul 13 21:30:52 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* random.c (read_pool): Simple alloc if secure_alloc is not set.
	(get_random_bits): Ditto.

Thu Jul  9 13:01:14 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* dynload.c (load_extension): Function now nbails out if
	the program is run setuid.

Wed Jul  8 18:58:23 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* rmd160.c (rmd160_hash_buffer): New.

Thu Jul  2 10:50:30 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* cipher.c (cipher_open): algos >=100 use standard CFB

Thu Jun 25 11:18:25 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* Makefile.am: Support for extensions

Thu Jun 18 12:09:38 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* random.c (mix_pool): simpler handling for level 0

Mon Jun 15 14:40:48 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* tiger.c: Removed from dist, will reappear as dynload module

Sat Jun 13 14:16:57 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* pubkey.c: Major changes to allow extensions. Changed the inteface
	of all public key ciphers and added the ability to load extensions
	on demand.

	* misc.c: Removed.

Wed Jun 10 07:52:08 1998  Werner Koch,mobil,,,	(wk@tobold)

	* dynload.c: New.
	* cipher.c: Major changes to allow extensions.

Mon Jun  8 22:43:00 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* cipher.c: Major internal chnages to support extensions.
	* blowfish.c (blowfish_get_info): New and made all internal
	functions static, changed heder.
	* cast5.c (cast5_get_info): Likewise.

Mon Jun  8 12:27:52 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* tiger.c (transform): Fix for big endian

	* cipher.c (do_cfb_decrypt): Big endian fix.

Fri May 22 07:30:39 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* md.c (md_get_oid): Add a new one for TIGER.

Thu May 21 13:24:52 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* cipher.c: Add support for a dummy cipher

Thu May 14 15:40:36 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* rmd160.c (transform): fixed sigbus - I should better
	add Christian von Roques's new implemenation of rmd160_write.

Fri May  8 18:07:44 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* rand-internal.h, rand-unix.c, rand-w32.c, rand_dummy.c: New
	* random.c: Moved system specific functions to rand-****.c

Fri May  8 14:01:17 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* random.c (fast_random_poll): add call to gethrtime.

Tue May  5 21:28:55 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* elgamal.c (elg_generate): choosing x was not correct, could
	yield 6 bytes which are not from the random pool, tsss, tsss..

Tue May  5 14:09:06 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* primegen.c (generate_elg_prime): Add arg mode, changed all
	callers and implemented mode 1.

Mon Apr 27 14:41:58 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* cipher.c (cipher_get_keylen): New.

Sun Apr 26 14:44:52 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* tiger.c, tiger.h: New.

Wed Apr  8 14:57:11 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* misc.c (check_pubkey_algo2): New.

Tue Apr  7 18:46:49 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* cipher.c: New
	* misc.c (check_cipher_algo): Moved to cipher.c
	* cast5.c: Moved many functions to cipher.c
	* blowfish.c: Likewise.

Sat Apr  4 19:52:08 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* cast5.c: Implemented and tested.

Wed Apr  1 16:38:27 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* elgamal.c (elg_generate): Faster generation of x in some cases.

Thu Mar 19 13:54:48 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* blowfish.c (blowfish_decode_cfb): changed XOR operation
	(blowfish_encode_cfb): Ditto.

Thu Mar 12 14:04:05 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* sha1.c (transform): Rewrote

	* blowfish.c (encrypt): Unrolled for rounds == 16
	(decrypt): Ditto.

Tue Mar 10 16:32:08 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* rmd160.c (transform): Unrolled the loop.

Tue Mar 10 13:05:14 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* random.c (read_pool): Add pool_balance stuff.
	(get_random_bits): New.

	* elgamal.c (elg_generate): Now uses get_random_bits to generate x.


Tue Mar 10 11:33:51 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* md.c (md_digest_length): New.

Tue Mar 10 11:27:41 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* dsa.c (dsa_verify): Works.

Mon Mar  9 12:59:08 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* dsa.c, dsa.h: Removed some unused code.

Wed Mar  4 10:39:22 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* md.c (md_open): Add call to fast_random_poll.
	blowfish.c (blowfish_setkey): Ditto.

Tue Mar  3 13:32:54 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* rmd160.c (rmd160_mixblock): New.
	* random.c: Restructured to start with a new RNG implementation.
	* random.h: New.

Mon Mar  2 19:21:46 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* gost.c, gost.h: Removed because they did only conatin trash.

Sun Mar  1 16:42:29 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* random.c (fill_buffer): removed error message if n == -1.

Fri Feb 27 16:39:34 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* md.c (md_enable): No init if called twice.

Thu Feb 26 07:57:02 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* primegen.c (generate_elg_prime): Changed the progress printing.
	(gen_prime): Ditto.

Tue Feb 24 12:28:42 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* md5.c, md.5 : Replaced by a modified version of md5.c from
	GNU textutils 1.22.

Wed Feb 18 14:08:30 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* md.c, md.h : New debugging support

Mon Feb 16 10:08:47 1998  Werner Koch  (wk@isil.d.shuttle.de)

	* misc.c (cipher_algo_to_string): New
	(pubkey_algo_to_string): New.
	(digest_algo_to_string): New.



 Copyright 1998, 1999, 2000, 2001, 2002, 2003,
	   2004, 2005 Free Software Foundation, Inc.

 This file is free software; as a special exception the author gives
 unlimited permission to copy and/or distribute it, with or without
 modifications, as long as this notice is preserved.

 This file is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
 implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
